"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
function useSuspensible(value, isFinish = (value) => value != null) {
    const handlerRef = react_1.useRef(null);
    if (isFinish(value)) {
        if (handlerRef.current) {
            const { resolve } = handlerRef.current;
            handlerRef.current = null;
            resolve();
        }
    }
    else {
        if (!handlerRef.current) {
            const handler = {};
            handler.suspender = new Promise(resolve => {
                handler.resolve = resolve;
            });
            handlerRef.current = handler;
        }
        throw handlerRef.current.suspender;
    }
}
exports.useSuspensible = useSuspensible;
//# sourceMappingURL=use-suspensible.js.map