import { useRef } from 'react';
export function useSuspensible(value, isFinish = (value) => value != null) {
    const handlerRef = useRef(null);
    if (isFinish(value)) {
        if (handlerRef.current) {
            const { resolve } = handlerRef.current;
            handlerRef.current = null;
            resolve();
        }
    }
    else {
        if (!handlerRef.current) {
            const handler = {};
            handler.suspender = new Promise(resolve => {
                handler.resolve = resolve;
            });
            handlerRef.current = handler;
        }
        throw handlerRef.current.suspender;
    }
}
//# sourceMappingURL=use-suspensible.js.map